[ACM] hdu 1342 Lotto (排列)

Lotto

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 1360    Accepted Submission(s): 679


Problem Description
In a Lotto I have ever played, one has to select 6 numbers from the set {1,2,...,49}. A popular strategy to play Lotto - although it doesn't increase your chance of winning - is to select a subset S containing k (k>6) of these 49 numbers, and then play several games with choosing numbers only from S. For example, for k=8 and S = {1,2,3,5,8,13,21,34} there are 28 possible games: [1,2,3,5,8,13], [1,2,3,5,8,21], [1,2,3,5,8,34], [1,2,3,5,13,21], ... [3,5,8,13,21,34].

Your job is to write a program that reads in the number k and the set S and then prints all possible games choosing numbers only from S.
 


 

Input
The input file will contain one or more test cases. Each test case consists of one line containing several integers separated from each other by spaces. The first integer on the line will be the number k (6 < k < 13). Then k integers, specifying the set S, will follow in ascending order. Input will be terminated by a value of zero (0) for k.
 


 

Output
For each test case, print all possible games, each game on one line. The numbers of each game have to be sorted in ascending order and separated from each other by exactly one space. The games themselves have to be sorted lexicographically, that means sorted by the lowest number first, then by the second lowest and so on, as demonstrated in the sample output below. The test cases have to be separated from each other by exactly one blank line. Do not put a blank line after the last test case.
 


 

Sample Input
7 1 2 3 4 5 6 7 8 1 2 3 5 8 13 21 34 0
 


 

Sample Output
1 2 3 4 5 6 1 2 3 4 5 7 1 2 3 4 6 7 1 2 3 5 6 7 1 2 4 5 6 7 1 3 4 5 6 7 2 3 4 5 6 7 1 2 3 5 8 13 1 2 3 5 8 21 1 2 3 5 8 34 1 2 3 5 13 21 1 2 3 5 13 34 1 2 3 5 21 34 1 2 3 8 13 21 1 2 3 8 13 34 1 2 3 8 21 34 1 2 3 13 21 34 1 2 5 8 13 21 1 2 5 8 13 34 1 2 5 8 21 34 1 2 5 13 21 34 1 2 8 13 21 34 1 3 5 8 13 21 1 3 5 8 13 34 1 3 5 8 21 34 1 3 5 13 21 34 1 3 8 13 21 34 1 5 8 13 21 34 2 3 5 8 13 21 2 3 5 8 13 34 2 3 5 8 21 34 2 3 5 13 21 34 2 3 8 13 21 34 2 5 8 13 21 34 3 5 8 13 21 34
 


 

Source

解题思路:

用全排列的思想,做了半天没做出来,出了好多问题,比如数字重复,数字没递增,数字比上次输出的小等等。看了别人的结题报告才发现自己忽视了一个重要的问题,该题和全排列取六个数不同,它要求取出的六个数是递增的,所以在用dfs搜索的时候,不能只用一个参数,还要记录下次搜索的位置,即上个数的下一个。

代码:

#include <iostream>
#include <algorithm>
#include <string.h>
using namespace std;

int num[14],k;
int p[7];

void dfs(int step,int cur)
{
    if(step>6)
    {
        for(int i=1;i<=5;i++)
            cout<<p[i]<<" ";cout<<p[6];
        cout<<endl;
    }
    else
    {
        for(int i=cur;i<=k;i++)//注意这个i不是从第一个数开始,而是从以确定的数下一个开始。这是题意决定的。
        {
            p[step]=num[i];
            dfs(step+1,i+1);//和全排列不同的地方,注意是i+1
        }
    }
}

int main()
{
    int flag=0;
    while(cin>>k&&k)
    {
        if(flag)
        cout<<endl;
        for(int i=1;i<=k;i++)
            cin>>num[i];
        dfs(1,1);//后面的参数保证搜索下一个数时不从数组中的第一个数开始,而是从以确定的数的下一个开始,保证了递增
        flag=1;
    }
    return 0;
}


 

原文地址:https://www.cnblogs.com/vivider/p/3697524.html